Module jdk.scripting.nashorn
Package jdk.nashorn.api.tree

## Enum Tree.Kind

- java.lang.Object
- - java.lang.Enum<Tree.Kind>
  - - jdk.nashorn.api.tree.Tree.Kind

- All Implemented Interfaces:
    `Serializable`, `Comparable<Tree.Kind>`, `Constable`
  Enclosing interface:
    Tree

      @Deprecated(since="11",
                  forRemoval=true)
      public static enum Tree.Kind
      extends Enum<Tree.Kind>

  Deprecated, for removal: This API element is subject to removal in a future version.
  Nashorn JavaScript script engine and APIs, and the jjs tool are deprecated with the intent to remove them in a future release.
  Enumerates all kinds of trees.

- - ### Nested Class Summary

    - ### Nested classes/interfaces declared in class java.lang.Enum

      `Enum.EnumDesc<E extends Enum<E>>`

  - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `AND` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing bitwise and logical "and" `&`.
    `AND_ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompoundAssignmentTree` representing bitwise and logical "and" assignment `&=`.
    `ARRAY_ACCESS` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ArrayAccessTree`.
    `ARRAY_LITERAL` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ArrayLiteralTree`.
    `ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `AssignmentTree`.
    `BITWISE_COMPLEMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `UnaryTree` representing bitwise complement operator `~`.
    `BLOCK` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BlockTree`.
    `BOOLEAN_LITERAL` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `LiteralTree` representing a boolean literal expression of type `boolean`.
    `BREAK` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BreakTree`.
    `CASE` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CaseTree`.
    `CATCH` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CatchTree`.
    `CLASS` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ClassDeclarationTree`.
    `CLASS_EXPRESSION` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ClassExpressionTree`.
    `COMMA` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing comma `,`.
    `COMPILATION_UNIT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompilationUnitTree`.
    `CONDITIONAL_AND` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing conditional-and `&&`.
    `CONDITIONAL_EXPRESSION` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ConditionalExpressionTree`.
    `CONDITIONAL_OR` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing conditional-or `||`.
    `CONTINUE` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ContinueTree`.
    `DEBUGGER` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `DebuggerTree`.
    `DELETE` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `UnaryTree` representing logical delete operator `delete`.
    `DIVIDE` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing division `/`.
    `DIVIDE_ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompoundAssignmentTree` representing division assignment `/=`.
    `DO_WHILE_LOOP` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `DoWhileLoopTree`.
    `EMPTY_STATEMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `EmptyStatementTree`.
    `EQUAL_TO` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing equal-to `==`.
    `ERROR` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ErroneousTree`.
    `EXPORT_ENTRY` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ExportEntryTree`.
    `EXPRESSION_STATEMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ExpressionStatementTree`.
    `FOR_IN_LOOP` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ForInLoopTree`.
    `FOR_LOOP` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ForLoopTree`.
    `FUNCTION` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `FunctionDeclarationTree`.
    `FUNCTION_EXPRESSION` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `FunctionExpressionTree`.
    `FUNCTION_INVOCATION` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `FunctionCallTree`.
    `GREATER_THAN` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing greater-than `>`.
    `GREATER_THAN_EQUAL` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing greater-than-equal `>=`.
    `IDENTIFIER` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `IdentifierTree`.
    `IF` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `IfTree`.
    `IMPORT_ENTRY` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ImportEntryTree`.
    `IN` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing in operator `in`.
    `INSTANCE_OF` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `InstanceOfTree`.
    `LABELED_STATEMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `LabeledStatementTree`.
    `LEFT_SHIFT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing left shift `<<`.
    `LEFT_SHIFT_ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompoundAssignmentTree` representing left shift assignment `<<=`.
    `LESS_THAN` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing less-than `<`.
    `LESS_THAN_EQUAL` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing less-than-equal `<=`.
    `LOGICAL_COMPLEMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `UnaryTree` representing logical complement operator `!`.
    `MEMBER_SELECT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `MemberSelectTree`.
    `MINUS` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing subtraction `-`.
    `MINUS_ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompoundAssignmentTree` representing subtraction assignment `-=`.
    `MODULE` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ModuleTree`.
    `MULTIPLY` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing multiplication `*`.
    `MULTIPLY_ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompoundAssignmentTree` representing multiplication assignment `*=`.
    `NEW` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `NewTree`.
    `NOT_EQUAL_TO` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing not-equal-to `!=`.
    `NULL_LITERAL` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `LiteralTree` representing the use of `null`.
    `NUMBER_LITERAL` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `LiteralTree` representing a number literal expression of type `double`.
    `OBJECT_LITERAL` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ObjectLiteralTree`.
    `OR` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing bitwise and logical "or" `|`.
    `OR_ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompoundAssignmentTree` representing bitwise and logical "or" assignment `|=`.
    `OTHER` | Deprecated, for removal: This API element is subject to removal in a future version. An implementation-reserved node.
    `PARENTHESIZED` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ParenthesizedTree`.
    `PLUS` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing addition or string concatenation `+`.
    `PLUS_ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompoundAssignmentTree` representing addition or string concatenation assignment `+=`.
    `POSTFIX_DECREMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `UnaryTree` representing postfix decrement operator `--`.
    `POSTFIX_INCREMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `UnaryTree` representing postfix increment operator `++`.
    `PREFIX_DECREMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `UnaryTree` representing prefix decrement operator `--`.
    `PREFIX_INCREMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `UnaryTree` representing prefix increment operator `++`.
    `PROPERTY` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `PropertyTree`.
    `REGEXP_LITERAL` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `RegExpLiteralTree`.
    `REMAINDER` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing remainder `%`.
    `REMAINDER_ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompoundAssignmentTree` representing remainder assignment `%=`.
    `RETURN` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ReturnTree`.
    `RIGHT_SHIFT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing right shift `>>`.
    `RIGHT_SHIFT_ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompoundAssignmentTree` representing right shift assignment `>>=`.
    `SPREAD` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `SpreadTree` representing spread "operator" for arrays and function call arguments.
    `STRICT_EQUAL_TO` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing equal-to `===`.
    `STRICT_NOT_EQUAL_TO` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing not-equal-to `!==`.
    `STRING_LITERAL` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `LiteralTree` representing a string literal expression of type `String`.
    `SWITCH` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `SwitchTree`.
    `TEMPLATE_LITERAL` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `TemplateLiteralTree`.
    `THROW` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `ThrowTree`.
    `TRY` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `TryTree`.
    `TYPEOF` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `UnaryTree` representing logical typeof operator `typeof`.
    `UNARY_MINUS` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `UnaryTree` representing unary minus operator `-`.
    `UNARY_PLUS` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `UnaryTree` representing unary plus operator `+`.
    `UNSIGNED_RIGHT_SHIFT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing unsigned right shift `>>>`.
    `UNSIGNED_RIGHT_SHIFT_ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompoundAssignmentTree` representing unsigned right shift assignment `>>>=`.
    `VARIABLE` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `VariableTree`.
    `VOID` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `UnaryTree` representing logical void operator `void`.
    `WHILE_LOOP` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `WhileLoopTree`.
    `WITH` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `WithTree`.
    `XOR` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `BinaryTree` representing bitwise and logical "xor" `^`.
    `XOR_ASSIGNMENT` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `CompoundAssignmentTree` representing bitwise and logical "xor" assignment `^=`.
    `YIELD` | Deprecated, for removal: This API element is subject to removal in a future version. Used for instances of `YieldTree` representing (generator) yield expression `yield expr`.

  - ### Method Summary

    Modifier and Type | Method | Description
    --- | --- | ---
    `Class<? extends Tree>` | `asInterface()` | Deprecated, for removal: This API element is subject to removal in a future version. Returns the associated interface type that uses this kind.
    `boolean` | `isExpression()` | Deprecated, for removal: This API element is subject to removal in a future version. Returns if this is an expression tree kind or not.
    `boolean` | `isLiteral()` | Deprecated, for removal: This API element is subject to removal in a future version. Returns if this is a literal tree kind or not.
    `boolean` | `isStatement()` | Deprecated, for removal: This API element is subject to removal in a future version. Returns if this is a statement tree kind or not.
    `static Tree.Kind` | `valueOf​(String name)` | Deprecated, for removal: This API element is subject to removal in a future version. Returns the enum constant of this type with the specified name.
    `static Tree.Kind[]` | `values()` | Deprecated, for removal: This API element is subject to removal in a future version. Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods declared in class java.lang.Enum

      `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods declared in class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### ARRAY_ACCESS

          public static final Tree.Kind ARRAY_ACCESS

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ArrayAccessTree`.

    - #### ARRAY_LITERAL

          public static final Tree.Kind ARRAY_LITERAL

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ArrayLiteralTree`.

    - #### ASSIGNMENT

          public static final Tree.Kind ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `AssignmentTree`.

    - #### BLOCK

          public static final Tree.Kind BLOCK

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BlockTree`.

    - #### BREAK

          public static final Tree.Kind BREAK

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BreakTree`.

    - #### CLASS

          public static final Tree.Kind CLASS

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ClassDeclarationTree`.

    - #### CLASS_EXPRESSION

          public static final Tree.Kind CLASS_EXPRESSION

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ClassExpressionTree`.

    - #### CASE

          public static final Tree.Kind CASE

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CaseTree`.

    - #### CATCH

          public static final Tree.Kind CATCH

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CatchTree`.

    - #### COMPILATION_UNIT

          public static final Tree.Kind COMPILATION_UNIT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompilationUnitTree`.

    - #### CONDITIONAL_EXPRESSION

          public static final Tree.Kind CONDITIONAL_EXPRESSION

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ConditionalExpressionTree`.

    - #### CONTINUE

          public static final Tree.Kind CONTINUE

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ContinueTree`.

    - #### DO_WHILE_LOOP

          public static final Tree.Kind DO_WHILE_LOOP

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `DoWhileLoopTree`.

    - #### DEBUGGER

          public static final Tree.Kind DEBUGGER

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `DebuggerTree`.

    - #### FOR_IN_LOOP

          public static final Tree.Kind FOR_IN_LOOP

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ForInLoopTree`.

    - #### FUNCTION_EXPRESSION

          public static final Tree.Kind FUNCTION_EXPRESSION

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `FunctionExpressionTree`.

    - #### ERROR

          public static final Tree.Kind ERROR

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ErroneousTree`.

    - #### EXPRESSION_STATEMENT

          public static final Tree.Kind EXPRESSION_STATEMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ExpressionStatementTree`.

    - #### MEMBER_SELECT

          public static final Tree.Kind MEMBER_SELECT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `MemberSelectTree`.

    - #### FOR_LOOP

          public static final Tree.Kind FOR_LOOP

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ForLoopTree`.

    - #### IDENTIFIER

          public static final Tree.Kind IDENTIFIER

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `IdentifierTree`.

    - #### IF

          public static final Tree.Kind IF

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `IfTree`.

    - #### INSTANCE_OF

          public static final Tree.Kind INSTANCE_OF

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `InstanceOfTree`.

    - #### LABELED_STATEMENT

          public static final Tree.Kind LABELED_STATEMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `LabeledStatementTree`.

    - #### MODULE

          public static final Tree.Kind MODULE

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ModuleTree`.

    - #### EXPORT_ENTRY

          public static final Tree.Kind EXPORT_ENTRY

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ExportEntryTree`.

    - #### IMPORT_ENTRY

          public static final Tree.Kind IMPORT_ENTRY

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ImportEntryTree`.

    - #### FUNCTION

          public static final Tree.Kind FUNCTION

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `FunctionDeclarationTree`.

    - #### FUNCTION_INVOCATION

          public static final Tree.Kind FUNCTION_INVOCATION

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `FunctionCallTree`.

    - #### NEW

          public static final Tree.Kind NEW

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `NewTree`.

    - #### OBJECT_LITERAL

          public static final Tree.Kind OBJECT_LITERAL

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ObjectLiteralTree`.

    - #### PARENTHESIZED

          public static final Tree.Kind PARENTHESIZED

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ParenthesizedTree`.

    - #### PROPERTY

          public static final Tree.Kind PROPERTY

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `PropertyTree`.

    - #### REGEXP_LITERAL

          public static final Tree.Kind REGEXP_LITERAL

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `RegExpLiteralTree`.

    - #### TEMPLATE_LITERAL

          public static final Tree.Kind TEMPLATE_LITERAL

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `TemplateLiteralTree`.

    - #### RETURN

          public static final Tree.Kind RETURN

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ReturnTree`.

    - #### EMPTY_STATEMENT

          public static final Tree.Kind EMPTY_STATEMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `EmptyStatementTree`.

    - #### SWITCH

          public static final Tree.Kind SWITCH

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `SwitchTree`.

    - #### THROW

          public static final Tree.Kind THROW

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `ThrowTree`.

    - #### TRY

          public static final Tree.Kind TRY

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `TryTree`.

    - #### VARIABLE

          public static final Tree.Kind VARIABLE

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `VariableTree`.

    - #### WHILE_LOOP

          public static final Tree.Kind WHILE_LOOP

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `WhileLoopTree`.

    - #### WITH

          public static final Tree.Kind WITH

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `WithTree`.

    - #### POSTFIX_INCREMENT

          public static final Tree.Kind POSTFIX_INCREMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `UnaryTree` representing postfix increment operator `++`.

    - #### POSTFIX_DECREMENT

          public static final Tree.Kind POSTFIX_DECREMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `UnaryTree` representing postfix decrement operator `--`.

    - #### PREFIX_INCREMENT

          public static final Tree.Kind PREFIX_INCREMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `UnaryTree` representing prefix increment operator `++`.

    - #### PREFIX_DECREMENT

          public static final Tree.Kind PREFIX_DECREMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `UnaryTree` representing prefix decrement operator `--`.

    - #### UNARY_PLUS

          public static final Tree.Kind UNARY_PLUS

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `UnaryTree` representing unary plus operator `+`.

    - #### UNARY_MINUS

          public static final Tree.Kind UNARY_MINUS

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `UnaryTree` representing unary minus operator `-`.

    - #### BITWISE_COMPLEMENT

          public static final Tree.Kind BITWISE_COMPLEMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `UnaryTree` representing bitwise complement operator `~`.

    - #### LOGICAL_COMPLEMENT

          public static final Tree.Kind LOGICAL_COMPLEMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `UnaryTree` representing logical complement operator `!`.

    - #### DELETE

          public static final Tree.Kind DELETE

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `UnaryTree` representing logical delete operator `delete`.

    - #### TYPEOF

          public static final Tree.Kind TYPEOF

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `UnaryTree` representing logical typeof operator `typeof`.

    - #### VOID

          public static final Tree.Kind VOID

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `UnaryTree` representing logical void operator `void`.

    - #### COMMA

          public static final Tree.Kind COMMA

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing comma `,`.

    - #### MULTIPLY

          public static final Tree.Kind MULTIPLY

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing multiplication `*`.

    - #### DIVIDE

          public static final Tree.Kind DIVIDE

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing division `/`.

    - #### REMAINDER

          public static final Tree.Kind REMAINDER

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing remainder `%`.

    - #### PLUS

          public static final Tree.Kind PLUS

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing addition or string concatenation `+`.

    - #### MINUS

          public static final Tree.Kind MINUS

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing subtraction `-`.

    - #### LEFT_SHIFT

          public static final Tree.Kind LEFT_SHIFT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing left shift `<<`.

    - #### RIGHT_SHIFT

          public static final Tree.Kind RIGHT_SHIFT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing right shift `>>`.

    - #### UNSIGNED_RIGHT_SHIFT

          public static final Tree.Kind UNSIGNED_RIGHT_SHIFT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing unsigned right shift `>>>`.

    - #### LESS_THAN

          public static final Tree.Kind LESS_THAN

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing less-than `<`.

    - #### GREATER_THAN

          public static final Tree.Kind GREATER_THAN

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing greater-than `>`.

    - #### LESS_THAN_EQUAL

          public static final Tree.Kind LESS_THAN_EQUAL

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing less-than-equal `<=`.

    - #### GREATER_THAN_EQUAL

          public static final Tree.Kind GREATER_THAN_EQUAL

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing greater-than-equal `>=`.

    - #### IN

          public static final Tree.Kind IN

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing in operator `in`.

    - #### EQUAL_TO

          public static final Tree.Kind EQUAL_TO

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing equal-to `==`.

    - #### NOT_EQUAL_TO

          public static final Tree.Kind NOT_EQUAL_TO

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing not-equal-to `!=`.

    - #### STRICT_EQUAL_TO

          public static final Tree.Kind STRICT_EQUAL_TO

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing equal-to `===`.

    - #### STRICT_NOT_EQUAL_TO

          public static final Tree.Kind STRICT_NOT_EQUAL_TO

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing not-equal-to `!==`.

    - #### AND

          public static final Tree.Kind AND

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing bitwise and logical "and" `&`.

    - #### XOR

          public static final Tree.Kind XOR

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing bitwise and logical "xor" `^`.

    - #### OR

          public static final Tree.Kind OR

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing bitwise and logical "or" `|`.

    - #### CONDITIONAL_AND

          public static final Tree.Kind CONDITIONAL_AND

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing conditional-and `&&`.

    - #### CONDITIONAL_OR

          public static final Tree.Kind CONDITIONAL_OR

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `BinaryTree` representing conditional-or `||`.

    - #### MULTIPLY_ASSIGNMENT

          public static final Tree.Kind MULTIPLY_ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompoundAssignmentTree` representing multiplication assignment `*=`.

    - #### DIVIDE_ASSIGNMENT

          public static final Tree.Kind DIVIDE_ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompoundAssignmentTree` representing division assignment `/=`.

    - #### REMAINDER_ASSIGNMENT

          public static final Tree.Kind REMAINDER_ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompoundAssignmentTree` representing remainder assignment `%=`.

    - #### PLUS_ASSIGNMENT

          public static final Tree.Kind PLUS_ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompoundAssignmentTree` representing addition or string concatenation assignment `+=`.

    - #### MINUS_ASSIGNMENT

          public static final Tree.Kind MINUS_ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompoundAssignmentTree` representing subtraction assignment `-=`.

    - #### LEFT_SHIFT_ASSIGNMENT

          public static final Tree.Kind LEFT_SHIFT_ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompoundAssignmentTree` representing left shift assignment `<<=`.

    - #### RIGHT_SHIFT_ASSIGNMENT

          public static final Tree.Kind RIGHT_SHIFT_ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompoundAssignmentTree` representing right shift assignment `>>=`.

    - #### UNSIGNED_RIGHT_SHIFT_ASSIGNMENT

          public static final Tree.Kind UNSIGNED_RIGHT_SHIFT_ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompoundAssignmentTree` representing unsigned right shift assignment `>>>=`.

    - #### AND_ASSIGNMENT

          public static final Tree.Kind AND_ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompoundAssignmentTree` representing bitwise and logical "and" assignment `&=`.

    - #### XOR_ASSIGNMENT

          public static final Tree.Kind XOR_ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompoundAssignmentTree` representing bitwise and logical "xor" assignment `^=`.

    - #### OR_ASSIGNMENT

          public static final Tree.Kind OR_ASSIGNMENT

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `CompoundAssignmentTree` representing bitwise and logical "or" assignment `|=`.

    - #### SPREAD

          public static final Tree.Kind SPREAD

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `SpreadTree` representing spread "operator" for arrays and function call arguments.

    - #### YIELD

          public static final Tree.Kind YIELD

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `YieldTree` representing (generator) yield expression `yield expr`.

    - #### NUMBER_LITERAL

          public static final Tree.Kind NUMBER_LITERAL

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `LiteralTree` representing a number literal expression of type `double`.

    - #### BOOLEAN_LITERAL

          public static final Tree.Kind BOOLEAN_LITERAL

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `LiteralTree` representing a boolean literal expression of type `boolean`.

    - #### STRING_LITERAL

          public static final Tree.Kind STRING_LITERAL

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `LiteralTree` representing a string literal expression of type `String`.

    - #### NULL_LITERAL

          public static final Tree.Kind NULL_LITERAL

      Deprecated, for removal: This API element is subject to removal in a future version.
      Used for instances of `LiteralTree` representing the use of `null`.

    - #### OTHER

          public static final Tree.Kind OTHER

      Deprecated, for removal: This API element is subject to removal in a future version.
      An implementation-reserved node. This is the not the node you are looking for.

  - ### Method Detail

    - #### values

          public static Tree.Kind[] values()

      Deprecated, for removal: This API element is subject to removal in a future version.
      Returns an array containing the constants of this enum type, in the order they are declared.
      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Tree.Kind valueOf​(String name)

      Deprecated, for removal: This API element is subject to removal in a future version.
      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### asInterface

          public Class<? extends Tree> asInterface()

      Deprecated, for removal: This API element is subject to removal in a future version.
      Returns the associated interface type that uses this kind.
      Returns:
        the associated interface

    - #### isLiteral

          public boolean isLiteral()

      Deprecated, for removal: This API element is subject to removal in a future version.
      Returns if this is a literal tree kind or not.
      Returns:
        true if this is a literal tree kind, false otherwise

    - #### isExpression

          public boolean isExpression()

      Deprecated, for removal: This API element is subject to removal in a future version.
      Returns if this is an expression tree kind or not.
      Returns:
        true if this is an expression tree kind, false otherwise

    - #### isStatement

          public boolean isStatement()

      Deprecated, for removal: This API element is subject to removal in a future version.
      Returns if this is a statement tree kind or not.
      Returns:
        true if this is a statement tree kind, false otherwise